@echo OFF
REM Licensed Materials - Property of IBM
REM
REM (C) Copyright IBM Corp. 2007, 2010 All Rights Reserved
REM
REM US Government Users Restricted Rights - Use, duplicate or
REM disclosure restricted by GSA ADP Schedule Contract with
REM IBM Corp.

setlocal
REM something eats the directory stack, so we have to memorize instead. (no pushd)
set USERDIR=%CD%
set BINDIR=%~d0%~p0
cd /d %BINDIR%
set DIRECTOR_HOME=%~d0%~p0..\
SET DIR_HOME=%~d0%~p0..
set LWI_DIR=%BINDIR%..\lwi
call "%DIRECTOR_HOME%lwi\bin\setupCmdLine.bat"
set CURRENTDIR=%~d0%~p0
set ROOTDIR=%~d0%~p0..\
set LOGFILE=%ROOTDIR%log\reset.log

REM Figure out the path, regardless of patch level
for /D %%A in ("%DIRECTOR_HOME%lwi\runtime\USMiData\eclipse\plugins\com.ibm.usmi.kernel.persistence_*") do set PERSPLUGINPATH=%%A
REM Collapse all the repeats into a one liner
set PERSPROG=-cp "%PERSPLUGINPATH%\classes;%PERSPLUGINPATH%\classes\USMSPersTools.jar" com.ibm.usmi.kernel.persistence.USMSReset 

REM lots of jumps and odd checks thanks to no OR in BAT, and needing to check multiple inputs.
REM Check for help request
for %%D in ("-h", "--help") DO IF "%1"==%%D ( 
goto usage
)
REM Batch doesn't allow -? in the for loop
if "%1"=="-?" (
goto usage
)

REM Check for the noprompt option
for %%D in (%*) DO IF "-noprompt"=="%%D" ( 
 set NOPROMPT=1
)

for %%D in (%*) DO IF "-l"=="%%D" ( 
 set SMVERBOSE=1
)

if ""%1""==""""  goto doneSetArgs
if "%1"=="-l" (
 goto doneSetArgs
) else (
if "%1"=="-noprompt" goto runit
"%JAVA_PROGRAM%" %PERSPROG% badarguments
goto messageout
)

:doneSetArgs
REM clean up the log, if any
echo "" > "%LOGFILE%"

if "%NOPROMPT%"=="1" goto runit

REM let's check with the user if they really want to blow away the server
"%JAVA_PROGRAM%" %PERSPROG% areyousure
if exist message.txt type message.txt
if exist message.txt del message.txt > nul 2>&1
set /p resetit=
for %%E in ("1", "y", "yes", "Y", "YES") DO IF "%resetit%"==%%E ( 
  goto runit
)
goto messageout

:runit
REM Check to see if we are running, if we are, bail
call "%DIRECTOR_HOME%lwi\bin\lwistatus" > usmsstatus
find "INACTIVE" < usmsstatus > nul
if errorlevel 1 goto isrunning

REM run the file reset.. copies proddata/defaults to the data directory
"%JAVA_PROGRAM%" %PERSPROG% -log "%LOGFILE%" %*
set DATADIRRESET=%ERRORLEVEL%
if errorlevel 1 goto interupt

echo Non-DB portion of Reset Complete >> "%LOGFILE%"

REM Run JPA database setup 
:RUNDBSETUP	

REM Cleanup and prime the default JPA database
REM nls'd echo Cleaning up JPA Database
"%JAVA_PROGRAM%" %PERSPROG% jpaclean
if exist message.txt type message.txt 
if exist message.txt del message.txt > nul 2>&1

set DBCLASSPATH=%DIR_HOME%\bin;%LWI_DIR%\lib\lwisecurity.jar;%LWI_DIR%\lib\passutils.jar;%DIR_HOME%\bin\cfgdbcmd.jar

if "%SMVERBOSE%"=="1" (
"%DIRECTOR_HOME%jre\bin\java" -classpath "%DBCLASSPATH%" ^
		-DDirHome="%DIR_HOME%" ^
		-DLWIInstallLocation="%LWI_DIR%" ^
		com.ibm.usmi.install.dbconfig.LWIDbConfig -dbReset true -logfile "%DIRECTOR_HOME%log\reset-database.log" %*
set ERRORRC=%ERRORLEVEL%
) else (
"%DIRECTOR_HOME%jre\bin\java" -classpath "%DBCLASSPATH%" ^
		-DDirHome="%DIR_HOME%" ^
		-DLWIInstallLocation="%LWI_DIR%" ^
		com.ibm.usmi.install.dbconfig.LWIDbConfig -dbReset true -logfile "%DIRECTOR_HOME%log\reset-database.log" %* >> "%LOGFILE%" 2>&1
set ERRORRC=%ERRORLEVEL%
)

REM the only message we print if not verbose
if "%ERRORRC%"=="0" (
   if "%DATADIRRESET%"=="0" (
     if exist message.txt del message.txt > nul 2>&1
     "%JAVA_PROGRAM%" %PERSPROG% success
   )
) else (
  "%JAVA_PROGRAM%" %PERSPROG% -formatmessage cfgdbcmd %ERRORRC%
)
if exist message.txt type message.txt 
if exist message.txt del message.txt > nul 2>&1

cd %USERDIR%
exit /B %ERRORRC%
	
:isrunning
del usmsstatus >nul 2>&1
"%JAVA_PROGRAM%" %PERSPROG% isrunning
goto errorout
 
:interupt
cd "%BINDIR%"
if exist message.txt del message.txt > nul 2>&1
"%JAVA_PROGRAM%" %PERSPROG% ResetFailed
goto errorout

:usage
"%JAVA_PROGRAM%" %PERSPROG% helpmessage

:messageout
if exist message.txt type message.txt
if exist message.txt del message.txt > nul 2>&1
cd %USERDIR%
exit /b 0

:errorout
if exist message.txt type message.txt
if exist message.txt del message.txt > nul 2>&1
cd %USERDIR%
exit /b 1





