@echo OFF
REM Licensed Materials - Property of IBM
REM
REM (C) Copyright IBM Corp. 2007, 2010 All Rights Reserved
REM
REM US Government Users Restricted Rights - Use, duplicate or
REM disclosure restricted by GSA ADP Schedule Contract with
REM IBM Corp.
REM this batch program uses TPM's backup program to
REM execute a save of the database and the data directory


pushd
cd /d %0\..
set DIRECTOR_HOME=%~d0%~p0..\
REM set up the command line
call "%DIRECTOR_HOME%\lwi\bin\setupCmdLine.bat"

set PLATFORM_XML_FILE="%CONF_DIR%\org.eclipse.update\platform.xml"
set PLATFORM_XML_BACKUP_FILE="%CONF_DIR%\org.eclipse.update\.platform.xml.backup"

REM Check to see if we are running, if we are, bail
call "%DIRECTOR_HOME%\lwi\bin\lwistatus" > usmsstatus
find "INACTIVE" < usmsstatus > nul
if errorlevel 1 goto isrunning

REM setup our dirs
set CURRENTDIR=%~d0%~p0

REM preexecution validation
"%JAVA_PROGRAM%" -cp "%DIRECTOR_HOME%\bin\pdata\pextensions.jar" com.ibm.usmi.kernel.persistence.Validation Validate Restore %*
if errorlevel 1 goto done

rem
rem set LWI_DEBUG_ARGS=-Xdebug -Xnoagent -Xrunjdwp:transport=dt_socket,server=y,address=8000,suspend=n
rem

rem -- Execute the framewoek for restore operation --
@echo off
rem - Package the input arguments up so that they can be accessed by the framework plugin in LWI
rem  - In the case of paths with spaces --> -sourceDir "c:\Program Files\ibm\backups"
rem - The inner quotes need to be removed.  Final packaging needs to looks like this pArgs="-sourceDir c:\Program Files\ibm\backups"
rem - vs problem packaging like this --> pArgs="-sourceDir "c:\Program Files\ibm\backups""
rem - the below set command does a substitution of (") for blank...meaning to delete the quotes
set args=%*
set args=%args:"=%
rem ---
copy %PLATFORM_XML_FILE% %PLATFORM_XML_BACKUP_FILE%
call "%DIRECTOR_HOME%\lwi\bin\lwistart.bat" ^
profile.data=database,extended,USMiResource,USMiData com.ibm.lwi.profile=profile.data PDataOperation=Restore -console=false -noSplash=true pArgs="%args%" 
set prc=%errorlevel%
@echo off
cd %CURRENTDIR%

REM now clean up 
move %PLATFORM_XML_BACKUP_FILE% %PLATFORM_XML_FILE%
del usmsstatus >nul 2>&1
popd
"%JAVA_PROGRAM%" -cp "%DIRECTOR_HOME%\bin\pdata\pextensions.jar" com.ibm.usmi.kernel.persistence.Validation ExitStatus %prc%
exit /b %prc%

:isrunning
REM get the translated message....  through java this time.
"%JAVA_PROGRAM%" -cp "%DIRECTOR_HOME%\bin\pdata\pextensions.jar" com.ibm.usmi.kernel.persistence.Validation ServerRunning
popd
exit /b 1

:done
exit /b 1
